import * as React from 'react';
import React__default, { useState, useCallback } from 'react';
import Tilt from 'react-parallax-tilt';

const HovCardStyle$1 = (cardWidth, cardHeight, cardPadding, cardBorderWidth, cardBorderColor, cardBorderStyle, cardBorderRadius) => ({
    width: cardWidth ? cardWidth : '300px',
    height: cardHeight ? cardHeight : 'auto',
    padding: cardPadding ? cardPadding : '3px',
    borderWidth: cardBorderWidth ? cardBorderWidth : '4px',
    borderColor: cardBorderColor ? cardBorderColor : 'black',
    borderStyle: cardBorderStyle ? cardBorderStyle : 'solid',
    borderRadius: cardBorderRadius ? cardBorderRadius : '5px',
    boxShadow: 'rgba(50, 50, 93, 0.25) 0px 13px 27px -5px, rgba(0, 0, 0, 0.3) 0px 8px 16px -8px',
});
const HovcardStyleonHover$1 = (isHover, cardEndScale, cardStartScale) => ({
    transform: `scale(${isHover ? (cardEndScale || '1.5') : (cardStartScale || '1.1')})`,
    transition: '0.6s',
    marginBottom: '5px',
    marginTop: '3px',
});
const BtnStyle = (cardBtnColor, cardBtnBackgroundColor, cardBtnSize, cardBtnBorderRadius, marginTop) => ({
    color: cardBtnColor || 'white',
    backgroundColor: cardBtnBackgroundColor || 'black',
    fontSize: cardBtnSize || '18px',
    padding: '8px',
    borderRadius: cardBtnBorderRadius || '10px',
    textDecoration: 'none',
    textTransform: 'capitalize',
    marginTop: marginTop || '0px',
});

/**
 * In V1, it is normal card,
 * the button is added with links
 * Mostly depricated
 */
const HovCard = ({ cardWidth, cardHeight, cardPadding, cardBorderWidth, cardBorderColor, cardBorderStyle, cardBorderRadius, cardEndScale, cardStartScale, cardImgContent, cardImgWidth, cardImgHeight, cardTitle, cardTitleFontSize, cardDescpriptionFontFamily, cardDescpription, cardRandomText, link, cardBtnName, cardBtnColor, cardBtnBackgroundColor, cardBtnSize, cardBtnBorderRadius }) => {
    const [isHover, setIsHover] = useState(false);
    const handleMouseEnter = () => {
        setIsHover(true);
    };
    const handleMouseLeave = () => {
        setIsHover(false);
    };
    return (React.createElement("div", { className: 'hov-card-container' },
        React.createElement("div", null,
            React.createElement("div", { className: 'hov-card', style: HovCardStyle$1(cardWidth, cardHeight, cardPadding, cardBorderWidth, cardBorderColor, cardBorderStyle, cardBorderRadius) },
                React.createElement("div", { className: 'hov-card-style', style: HovcardStyleonHover$1(isHover, cardEndScale, cardStartScale), onMouseEnter: handleMouseEnter, onMouseLeave: handleMouseLeave },
                    React.createElement(Tilt, null,
                        React.createElement("img", { src: cardImgContent ? cardImgContent : "https://i.ibb.co/XbMzrd9/monster.png", alt: "imgpls", width: cardImgWidth ? cardImgWidth : '300px', height: cardImgHeight ? cardImgHeight : '200px' }))),
                React.createElement("div", null,
                    React.createElement("h1", { style: { fontSize: cardTitleFontSize ? cardTitleFontSize : '32px' } }, cardTitle ? cardTitle : 'Title'),
                    React.createElement("p", { style: { fontFamily: cardDescpriptionFontFamily ? cardDescpriptionFontFamily : 'Roboto' } }, cardDescpription ? cardDescpription : 'Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book.'),
                    React.createElement("h6", null, cardRandomText)),
                React.createElement("div", { className: 'hov-card-btn', style: { marginBottom: '10px' } },
                    React.createElement("a", { href: link ? link : 'https://www.youtube.com/', style: BtnStyle(cardBtnColor, cardBtnBackgroundColor, cardBtnSize, cardBtnBorderRadius) }, cardBtnName ? cardBtnName : 'click me'))))));
};

const HovCardStyle = (props) => ({
    width: props.cardWidth || '300px',
    height: props.cardHeight || 'auto',
    padding: props.cardPadding || '3px',
    borderWidth: props.cardBorderWidth || '4px',
    borderColor: props.cardBorderColor || '#00bfff',
    borderStyle: props.cardBorderStyle || 'solid',
    borderRadius: props.cardBorderRadius || '5px',
    boxShadow: props.cardBoxShadow || 'rgb(38, 57, 77) 0px 20px 30px -10px',
    backgroundColor: props.cardBackgroundColor || '#00bfff',
});
const HovcardStyleonHover = (isHover, props) => ({
    transform: `scale(${isHover ? (props.cardEndScale || '1.5') : (props.cardStartScale || '1.1')})`,
    transition: '0.6s',
    marginBottom: '5px',
    marginTop: '3px',
});
const BtnStyle1 = (props) => ({
    color: props.cardBtnColor1 || 'white',
    backgroundColor: props.cardBtnBackgroundColor1 || 'black',
    fontSize: props.cardBtnSize1 || '18px',
    padding: '8px',
    borderRadius: props.cardBtnBorderRadius1 || '10px',
    textDecoration: 'none',
    textTransform: 'capitalize',
    height: props.cardBtnHeight1 || '28px',
    width: props.cardBtnWidth1 || '80px',
    display: 'flex',
    justifyContent: 'center',
    alignItems: 'center',
});
const BtnStyle2 = (props) => ({
    color: props.cardBtnColor2 || 'white',
    backgroundColor: props.cardBtnBackgroundColor2 || 'blue',
    fontSize: props.cardBtnSize2 || '18px',
    padding: '8px',
    borderRadius: props.cardBtnBorderRadius2 || '10px',
    textDecoration: 'none',
    textTransform: 'capitalize',
    display: props.cardButton2Enabled ? 'flex' : 'none',
    height: props.cardBtnHeight2 || '28px',
    width: props.cardBtnWidth2 || '80px',
    justifyContent: 'center',
    alignItems: 'center',
});
const containerStyle = (props) => ({
    backgroundColor: props.cardBackgroundBodyColor || '#00bfff',
});
const headerStyle = (props) => ({
    fontSize: props.cardTitleFontSize || '32px',
});
const subtitleStyle = (props) => ({
    fontSize: props.cardSubtitleFontSize || '20px',
    lineHeight: '0px',
    textAlign: 'left',
    marginLeft: '12px',
    display: props.cardSubtitleEnable ? 'block' : 'none',
});
const bodyStyle = (props) => ({
    margin: '3px',
});
const descriptionStyle = (props) => ({
    fontFamily: props.cardDescpriptionFontFamily || 'Roboto',
    fontSize: props.cardDescpriptionFontSize || '16px',
});
const buttonContainerStyle = (props) => ({
    marginBottom: '0px',
    display: 'flex',
    justifyContent: 'space-evenly',
});

function useCustomButtonClick(onClick) {
    const handleClick = useCallback(() => {
        onClick();
    }, [onClick]);
    return handleClick;
}

/**
 * In V2, The code in one level above V1,
 
 * Added 2 buttons, with custom button clicks
 * which can be used as single or double buttons by enabling and disabling buttons
 
 * Added sub title , with custom subtitle
 * which can be enabled and disabled
 
 * V2.1
 * Added Customizable BoxShadow,
 * Added background color for entire card and body
 * code moved to 1.1 level up
 
 * V2.2 (soon)
 * will be adding the customizable properties of the tilt
 * adding isHover and tilt required
 
 */
const HovCardV2 = (props) => {
    const [isHover, setIsHover] = useState(false);
    const handleMouseEnter = () => setIsHover(true);
    const handleMouseLeave = () => setIsHover(false);
    const handleButtonClick1 = useCustomButtonClick(props.onCustomClick1 || (() => { }));
    const handleButtonClick2 = useCustomButtonClick(props.onCustomClick2 || (() => { }));
    props.isHoverEnabled = props.isHoverEnabled ? true : false;
    return (React__default.createElement("div", { className: 'hov-card-container' },
        React__default.createElement("div", null,
            React__default.createElement("div", { className: 'hov-card', style: HovCardStyle(props) },
                React__default.createElement("div", { className: 'hov-card-style', style: HovcardStyleonHover(isHover, props), onMouseEnter: handleMouseEnter, onMouseLeave: handleMouseLeave }, props.isHoverEnabled ? (React__default.createElement(Tilt, null,
                    React__default.createElement("img", { src: props.cardImgContent || "https://i.ibb.co/XbMzrd9/monster.png", alt: "imgpls", width: props.cardImgWidth || '250px', height: props.cardImgHeight || '200px' }))) : (React__default.createElement("img", { src: props.cardImgContent || "https://i.ibb.co/XbMzrd9/monster.png", alt: "imgpls", width: props.cardImgWidth || '250px', height: props.cardImgHeight || '200px' }))),
                React__default.createElement("div", { style: containerStyle(props) },
                    React__default.createElement("div", { className: "hov-card-header" },
                        React__default.createElement("h1", { style: headerStyle(props) }, props.cardTitle || 'Monster'),
                        React__default.createElement("h5", { style: subtitleStyle(props) }, props.cardSubtitle || 'Funny Monster')),
                    React__default.createElement("div", { className: "hov-card-body", style: bodyStyle() },
                        React__default.createElement("p", { style: descriptionStyle(props) }, props.cardDescpription || "A person who is very cruel and evil, or who provokes or elicits horror by their wickedness. For example, The man is a monster; he terrifies me"),
                        React__default.createElement("h6", null, props.cardRandomText)),
                    React__default.createElement("div", { className: 'hov-card-btn', style: buttonContainerStyle() },
                        React__default.createElement("a", { style: BtnStyle1(props), onClick: handleButtonClick1 }, props.cardBtnName1 || 'Button 1'),
                        React__default.createElement("a", { style: BtnStyle2(props), onClick: handleButtonClick2 }, props.cardBtnName2 || 'Button 2')))))));
};

const getHovCardStyles = (props) => ({
    display: 'flex',
    alignItems: 'center',
    width: props.cardWidth || '600px',
    height: props.cardHeight || 'auto',
    padding: props.cardPadding || '3px',
    borderWidth: props.cardBorderWidth || '4px',
    borderColor: props.cardBorderColor || '#00bfff',
    borderStyle: props.cardBorderStyle || 'solid',
    borderRadius: props.cardBorderRadius || '5px',
    boxShadow: props.cardBoxShadow || 'rgb(38, 57, 77) 0px 20px 30px -10px',
    backgroundColor: props.cardBackgroundColor || '#00bfff',
});
const getHovCardImageStyles = (props, isHover) => ({
    transform: `scale(${isHover ? (props.cardEndScale || '1.5') : (props.cardStartScale || '1.1')})`,
    transition: '0.6s',
    marginRight: '20px',
});
const getButtonStyles = (color, backgroundColor, fontSize, borderRadius, height, width, display = 'flex') => ({
    color: color || 'white',
    backgroundColor: backgroundColor || 'black',
    fontSize: fontSize || '18px',
    padding: '8px',
    borderRadius: borderRadius || '10px',
    textDecoration: 'none',
    textTransform: 'capitalize',
    height: height || '28px',
    width: width || '80px',
    display: display,
    justifyContent: 'center',
    alignItems: 'center',
});
const getContainerStyles = (props) => ({
    flex: 1,
    backgroundColor: props.cardBackgroundBodyColor || '#00bfff',
    padding: '10px',
});
const getHeaderStyles = (props) => ({
    fontSize: props.cardTitleFontSize || '32px',
});
const getSubtitleStyles = (props) => ({
    fontSize: props.cardSubtitleFontSize || '20px',
    lineHeight: '0px',
    textAlign: 'left',
    marginLeft: '12px',
    display: props.cardSubtitleEnable ? 'block' : 'none',
});
const getBodyStyles = () => ({
    margin: '3px',
    maxWidth: '300px',
});
const getDescriptionStyles = (props) => ({
    fontFamily: props.cardDescpriptionFontFamily || 'Roboto',
    fontSize: props.cardDescpriptionFontSize || '16px',
    overflow: 'hidden',
    textOverflow: 'ellipsis',
    maxWidth: '100%',
});
const getButtonContainerStyles = () => ({
    marginTop: '20px',
    display: 'flex',
    justifyContent: 'space-evenly',
});

/**
 *
 * In H2,
 * Added Hover options for the image
 * @property isHoverEnabled
 *
 * IN H2.1
 * will be adding the customizable properties of the tilt
 *
 * **/
const HovCardH2 = (props) => {
    const [isHover, setIsHover] = useState(false);
    const handleMouseEnter = () => setIsHover(true);
    const handleMouseLeave = () => setIsHover(false);
    const handleButtonClick1 = useCustomButtonClick(props.onCustomClick1 || (() => { }));
    const handleButtonClick2 = useCustomButtonClick(props.onCustomClick2 || (() => { }));
    props.isHoverEnabled = props.isHoverEnabled ? true : false;
    return (React__default.createElement("div", { className: 'hov-card-container' },
        React__default.createElement("div", { className: 'hov-card', style: getHovCardStyles(props) },
            React__default.createElement("div", { className: 'hov-card-image', style: getHovCardImageStyles(props, isHover), onMouseEnter: handleMouseEnter, onMouseLeave: handleMouseLeave }, props.isHoverEnabled ? (React__default.createElement(Tilt, null,
                React__default.createElement("img", { src: props.cardImgContent || "https://i.ibb.co/XbMzrd9/monster.png", alt: "imgpls", width: props.cardImgWidth || '250px', height: props.cardImgHeight || '200px' }))) : (React__default.createElement("img", { src: props.cardImgContent || "https://i.ibb.co/XbMzrd9/monster.png", alt: "imgpls", width: props.cardImgWidth || '250px', height: props.cardImgHeight || '200px' }))),
            React__default.createElement("div", { style: getContainerStyles(props) },
                React__default.createElement("div", { className: "hov-card-header" },
                    React__default.createElement("h1", { style: getHeaderStyles(props) }, props.cardTitle || 'Monster'),
                    React__default.createElement("h5", { style: getSubtitleStyles(props) }, props.cardSubtitle || 'Funny Monster')),
                React__default.createElement("div", { className: "hov-card-body", style: getBodyStyles() },
                    React__default.createElement("p", { style: getDescriptionStyles(props), title: props.cardDescpription }, props.cardDescpription || "A person who is very cruel and evil, or who provokes or elicits horror by their wickedness."),
                    React__default.createElement("h6", null, props.cardRandomText)),
                React__default.createElement("div", { className: "hov-card-btn", style: getButtonContainerStyles() },
                    React__default.createElement("a", { className: "hov-card-btn1", style: getButtonStyles(props.cardBtnColor1, props.cardBtnBackgroundColor1, props.cardBtnSize1, props.cardBtnBorderRadius1, props.cardBtnHeight1, props.cardBtnWidth1), onClick: handleButtonClick1 }, props.cardBtnName1 || 'Button 1'),
                    React__default.createElement("a", { className: "hov-card-btn2", style: getButtonStyles(props.cardBtnColor2, props.cardBtnBackgroundColor2, props.cardBtnSize2, props.cardBtnBorderRadius2, undefined, undefined, props.cardButton2Enabled ? 'block' : 'none'), onClick: handleButtonClick2 }, props.cardBtnName2 || 'Button 2'))))));
};

export { HovCard, HovCardH2, HovCardV2 };
